<script lang="ts">
  import { ScoredPlayer, scorePlayer } from "../utils";

  export let players: Player[];
  export let paths: PlayerSuitPaths;

  let scoredPlayers: ScoredPlayer[];
  $: {
    scoredPlayers = players.map((p) => scorePlayer(p, paths[p.id]));
    scoredPlayers.sort((a, b) => b.rankValue - a.rankValue);
  }

  let winners: ScoredPlayer[];
  $: {
    if (scoredPlayers?.length > 0) {
      winners = scoredPlayers.filter(
        (p) => p.rankValue === scoredPlayers[0].rankValue
      );
    } else {
      winners = [];
    }
  }
</script>

<div class="wrapper">
  <h2>
    {#if winners.length === 1}
      <gs6-user playerid={winners[0].id} /> wins!
    {:else if winners.length === 2}
      <gs6-user playerid={winners[0].id} /> and
      <gs6-user playerid={winners[1].id} /> win!
    {:else}
      {#each winners as winner, idx}
        <gs6-user
          playerid={winner.id}
        />{#if idx < winners.length - 1},{" "}{/if}
        {#if idx === winners.length - 2}and{" "}{/if}
      {/each}
      win!
    {/if}
  </h2>

  <table>
    <thead>
      <tr>
        <th>#</th>
        <th>Player</th>
        <th>Score</th>
        <th>Park suits <br /> <small>(tiebreaker)</small></th>
      </tr>
    </thead>
    <tbody>
      {#each scoredPlayers as player}
        <tr>
          <td>
            {scoredPlayers.filter((p) => p.rankValue > player.rankValue)
              .length + 1}
          </td>
          <td><gs6-user playerid={player.id} /></td>
          <td class="center">
            {player.score}
          </td>
          <td class="center">
            {player.parkSuits}
          </td>
        </tr>
      {/each}
    </tbody>
  </table>
</div>

<style>
  h2 {
    font-weight: 500;
    text-align: center;
  }

  .wrapper {
    display: flex;
    flex-direction: column;
    align-items: center;
    max-width: 25em;
  }

  table {
    border-spacing: 0;
  }
  th {
    vertical-align: bottom;
    border-bottom: 1px solid #0007;
  }
  th,
  td {
    padding: 0.5em 1em;
  }
  th > small {
    font-weight: 400;
    filter: opacity(70%);
  }
  .center {
    text-align: center;
  }
</style>
